#!/bin/bash
#
# EeePC fan control
# Andrew Wyatt
# Tool to manage Eee PC fan
#

. /etc/default/eeepc-acpi

MAX_FAN_SPEED=100

if [ -e "/proc/eee/temperature" ]; then
  FAN_SPEED_CONTROL="/proc/eee/fan_speed"
  FAN_SWITCH="/proc/eee/fan_manual"
else
  /usr/bin/logger -p user.info "CRITICAL: UNABLE TO MANAGE FAN"
  exit 1
fi

if [ "$FAN_MODE" = "managed" ]; then
  echo 1 >$FAN_SWITCH
  for i in `seq 1 1 6`; do
    CURRENT_TEMP=$(cat /proc/eee/temperature)
    if [ "$CURRENT_TEMP" -ge "$TEMP_WARN" ]; then
     if [ "$CURRENT_TEMP" -ge "$TEMP_CRIT" ]; then
      echo $MAX_FAN_SPEED > $FAN_SPEED_CONTROL
     else
      echo $(echo "$MAX_FAN_SPEED-($MAX_FAN_SPEED*1/2)" | bc) > $FAN_SPEED_CONTROL
      fi
    else
      echo $(echo "$MAX_FAN_SPEED-($MAX_FAN_SPEED*1/1.42)" | bc) > $FAN_SPEED_CONTROL
    fi
    sleep 10
  done
else
  CURRENT_TEMP=$(cat /proc/eee/temperature)
  echo 0 > $FAN_SWITCH
fi
