#!/bin/bash
#
# EeePC VGA toggle
# Andrew Wyatt
# Tool to enable / disable VGA output

. /etc/default/eeepc-acpi

function eeepc_notify {
/usr/bin/notify-send -i display -t 1500 "EeePC $EEEPC_MODEL" "$1"
}
if [ -e "/tmp/eee-lvds-temp" ]; then
  rm -f /tmp/eee-lvds-temp 2>/dev/null
fi

if [ ! -d "$EEEPC_VAR" ]; then
  mkdir $EEEPC_VAR 2>/dev/null
fi

LVDS_XRANDR=$(xrandr > /tmp/eee-lvds-temp)
LVDS_STATUS=$(cat $EEEPC_VAR/lvds-state 2>/dev/null)
LVDS_CURRENT=$(cat /tmp/eee-lvds-temp | grep -F -e LVDS -A 12 | grep -F -e [0-9]x[0-9] -e "*" | awk '{print $1}')

if [ "$LVDS_STATUS" = "1" ]; then
  echo $LVDS_CURRENT > $EEEPC_VAR/lvds-resolution
  echo 0 > $EEEPC_VAR/lvds-state
  eeepc_notify "Display Off"
  xrandr --output LVDS --off
else
  if [ -e "$EEEPC_VAR/lvds-resolution" ]; then
    LVDS_RESTORE=$(cat $EEEPC_VAR/lvds-resolution)
    rm -f $EEEPC_VAR/lvds-resolution
  fi
  echo 1 > $EEEPC_VAR/lvds-state
  if [[ "$LVDS_RESTORE" =~ [0-9] ]]; then
    xrandr --output LVDS --mode $LVDS_RESTORE
  else
    xrandr --output LVDS --auto
  fi
  eeepc_notify "Display Enabled"
fi
rm /tmp/eee-lvds-temp 2>/dev/null
